﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Collections;
using GanttSample.Models;

namespace MVC09NewSample.Controllers
{
    public class GanttController : Controller
    {
        //
        // GET: /Gantt/

        public ActionResult Index()
        {
            var DataSource = GanttDefaultData.GetData();
            ViewBag.datasource = DataSource;
            var Resources = ResourceList.GetData();
            ViewBag.resources = Resources;
            return View();
        }

        public JsonResult GetData()
        {
            IEnumerable data = new DataClasses1DataContext().Appointments.Take(100); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public class ResourceList
        {
            public static List<ResourceListData> GetData()
            {
                List<ResourceListData> list = new List<ResourceListData>();

                list.Add(new ResourceListData() { Id = 1, Name = "Resource1" });
                list.Add(new ResourceListData() { Id = 2, Name = "Resource2" });
                list.Add(new ResourceListData() { Id = 3, Name = "Resource3" });
                list.Add(new ResourceListData() { Id = 4, Name = "Resource4" });
                list.Add(new ResourceListData() { Id = 5, Name = "Resource5" });
                list.Add(new ResourceListData() { Id = 6, Name = "Resource6" });
                list.Add(new ResourceListData() { Id = 7, Name = "Resource7" });
                return list;
            }
        }

        public class ResourceListData
        {
            public int Id { get; set; }
            public string Name { get; set; }
        }


        public class DefaultData
        {
            public string StartDate { get; set; }
            public string BaselineStartDate { get; set; }
            public string BaselineEndDate { get; set; }

            public int Id { get; set; }
            public string Name { get; set; }
            public string EndDate { get; set; }
            public string Duration { get; set; }
            public int PercentDone { get; set; }
            public List<object> ResourceId { get; set; }
            public List<DefaultData> Children { get; set; }
            public string Predescessor { get; set; }
        }


        public class GanttDefaultData
        {
            public static List<DefaultData> GetData()
            {
                List<DefaultData> list = new List<DefaultData>();
                list.Add(new DefaultData()
                {
                    Id = 1,
                    Name = "Parent Task 1",
                    StartDate = "02/23/2014 08:00:00 PM",
                    EndDate = "02/24/2014 08:00:00 PM",
                    Duration="50",
                    PercentDone = 40,
                    Children = (new List<DefaultData>()
                                 {
                                     new DefaultData()
                                      {
                                         Id = 2,
                                         Name = "Child Task 1",
                                         StartDate = "02/23/2014 08:00:00 PM",
                                         EndDate="02/25/2014 08:00:00 PM",
                                         PercentDone = 40,
                                         Duration="50",
                                         BaselineStartDate = "02/23/2014",
                                         BaselineEndDate = "02/29/2014",                                        
                                         ResourceId=new List<object>(){1,2}
                                      },
                                      new DefaultData()
                                      {
                                          Id = 3,
                                          Name = "Child Task 2",
                                          StartDate = "02/23/2014 08:00:00 PM",
                                          EndDate="02/25/2014 08:00:00 PM",
                                          PercentDone = 40,
                                          Duration="50",
                                          Predescessor = "2FS-1d",
                                          ResourceId=new List<object>(){4}
                                      },
                                      new DefaultData()
                                      {
                                          Id = 4,
                                          Name = "Child Task 3",
                                          StartDate = "02/23/2014 08:00:00 PM",
                                          EndDate="02/25/2014 08:00:00 PM",
                                          Duration="50",
                                          PercentDone = 40,
                                          ResourceId=new List<object>(){2}
                                      }
                                 })
                });
                list.Add(new DefaultData()
                {
                    Id = 5,
                    Name = "Parent Task 2",
                    StartDate = "02/24/2014 08:00:00 PM",
                    EndDate = "02/25/2014 08:00:00 PM",
                    PercentDone = 40,
                    Duration = "50",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 6,
                            Name = "Child Task 1",
                            StartDate = "02/24/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 7,
                            Name = "Child Task 2",
                            StartDate = "02/24/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            Predescessor = "6FS-2",
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 8,
                            Name = "Child Task 3",
                            StartDate = "02/24/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 9,
                            Name = "Child Task 4",
                            StartDate = "02/24/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            PercentDone = 40,
                            Predescessor = "6,7,8",
                        }
                    })
                });
                list.Add(new DefaultData()
                {
                    Id = 10,
                    Name = "Parent Task 3",
                    StartDate = "02/25/2014 08:00:00 PM",
                    EndDate = "02/28/2014 08:00:00 PM",
                    PercentDone = 40,
                    Duration = "50",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 11,
                            Name = "Child Task 1",
                            StartDate = "02/25/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 12,
                            Name = "Child Task 2",
                            StartDate = "02/25/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 13,
                            Name = "Child Task 3",
                            StartDate = "02/25/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            PercentDone = 40,
                            Duration="50",
                            Predescessor = "11,12",
                        },
                        new DefaultData()
                        {
                            Id = 12,
                            Name = "Child Task 4",
                            StartDate = "02/25/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            Duration="50",
                            PercentDone = 40,
                        },
                        new DefaultData()
                        {
                            Id = 13,
                            Name = "Child Task 50",
                            StartDate = "02/25/2014 08:00:00 PM",
                            EndDate="02/28/2014 08:00:00 PM",
                            PercentDone = 40,
                            Duration="50",
                            Predescessor = "11,12",
                        }
                    })
                });
                return list;
            }
        }
    }
}
